; ##############################################################################
; ##############################################################################
; ##############################################################################
; Version 10/2017																
;																				
; Ein Byte aus EEPROM holen und Z-Zeiger + 1									
;																				
; INPUT:	ZL Adresse (low)													
;			ZH Adresse (High)													
;																				
; OUTPUT: 	temp (DATEN)														
;																				
EEPROM_READ_Z_TEMP:
	sbic EECR,EEWE 		; Wait for completion of previous write
	rjmp EEPROM_READ_Z_TEMP
	out  EEARH, ZH		; ADRESSE setzen						
	out  EEARL, ZL
	sbi  EECR,EERE		; Start eeprom read by writing EERE		
	in 	 temp,EEDR		; Read data from data register			
	adiw ZL,1			; ADRESSE +1 							
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; Version 10/2017																
;																				
; Ein Byte im EEPROM ablegen und Z-Zeiger + 1									
;																				
; INPUT:	ZL Adresse (low)													
;			ZH Adresse (High)													
; 		 	temp  DATEN															
;																				
EEPROM_WRITE_Z_TEMP:
	sbic EECR,EEWE		; Wait for completion of previous write
	rjmp EEPROM_WRITE_Z_TEMP
	out  EEARH,ZH		; ADRESSE setzen						
	out  EEARL,ZL
	out  EEDR, temp		; Write data  to data register			
	sbi  EECR, EEMWE	; Write logical one to EEMWE			
	sbi  EECR, EEWE		; Start eeprom write by setting EEWE	
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
EEPROM_LOAD:
	ldi ZL,low (2)
	ldi ZH,high(2)
	rcall EEPROM_READ_Z_TEMP
	STS(adr_P_MAX_L),temp

	ldi ZL,low (3)
	ldi ZH,high(3)
	rcall EEPROM_READ_Z_TEMP
	STS(adr_P_MAX_H),temp
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
EEPROM_SAVE:
	ldi ZL,low (2)
	ldi ZH,high(2)
	LDS temp,(adr_P_MAX_L)
	rcall EEPROM_WRITE_Z_TEMP

	GELB_ON
	rcall WAIT_100ms

	ldi ZL,low (3)
	ldi ZH,high(3)
	LDS temp,(adr_P_MAX_H)
	rcall EEPROM_WRITE_Z_TEMP
	GELB_OFF
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################

